/*
 * @(#)ServletFilter.cpp	1.3 97/04/17
 * 
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */

#include <stdio.h>
#include <HttpExt.h>
#include <HttpFilt.h>

#undef AFX_DATA
#define AFX_DATA AFX_EXT_DATA

#define BUFSIZE     256
#define URLHEADER   "url"
#define SERVLETPATH "/servlet/"

static unsigned long oldPrefixLen, newPrefixLen, byteToSkip;

// needs to match the name of extension dll
static char dllPath[] = "/scripts/servlet.dll/";

BOOL WINAPI GetFilterVersion(HTTP_FILTER_VERSION *pVer)
{

	pVer->dwFilterVersion = HTTP_FILTER_REVISION;
	strcpy(pVer->lpszFilterDesc, "This filter maps /servlets to /scripts/servlet.dll");
	pVer->dwFlags &= ~SF_NOTIFY_ORDER_MASK;
	pVer->dwFlags |= SF_NOTIFY_PREPROC_HEADERS | 
		SF_NOTIFY_ORDER_HIGH | SF_NOTIFY_SECURE_PORT | SF_NOTIFY_NONSECURE_PORT;

	oldPrefixLen = strlen(SERVLETPATH);
	newPrefixLen = strlen(dllPath);
	byteToSkip = newPrefixLen - oldPrefixLen;

	return TRUE;
}


DWORD WINAPI HttpFilterProc(HTTP_FILTER_CONTEXT *pfc,
			    DWORD notificationType, 
			    LPVOID pvNotification)
{
	char buf[BUFSIZE], *bptr;
	unsigned long len = BUFSIZE - byteToSkip;
	bptr = &buf[byteToSkip];

	if (notificationType == SF_NOTIFY_PREPROC_HEADERS) {
		HTTP_FILTER_PREPROC_HEADERS *pHeaderInfo = 
			(HTTP_FILTER_PREPROC_HEADERS *) pvNotification;
		pHeaderInfo->GetHeader(pfc, URLHEADER, bptr, &len);

		if (len > oldPrefixLen && !strncmp(bptr, SERVLETPATH, oldPrefixLen)) {
			memcpy(buf, dllPath, newPrefixLen);
			pHeaderInfo->SetHeader(pfc, URLHEADER, buf);

		}
	}
	return SF_STATUS_REQ_NEXT_NOTIFICATION;
}


#undef AFX_DATA
#define AFX_DATA
